from google.protobuf import timestamp_pb2 as _timestamp_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import sources as _sources_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import common as _common_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class Changepoint(_message.Message):
    __slots__ = ["nominal_start_position", "previous_segment_nominal_end_position", "project", "ref", "ref_hash", "start_hour", "start_position_lower_bound_99th", "start_position_upper_bound_99th", "test_id", "variant", "variant_hash"]
    NOMINAL_START_POSITION_FIELD_NUMBER: _ClassVar[int]
    PREVIOUS_SEGMENT_NOMINAL_END_POSITION_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REF_FIELD_NUMBER: _ClassVar[int]
    REF_HASH_FIELD_NUMBER: _ClassVar[int]
    START_HOUR_FIELD_NUMBER: _ClassVar[int]
    START_POSITION_LOWER_BOUND_99TH_FIELD_NUMBER: _ClassVar[int]
    START_POSITION_UPPER_BOUND_99TH_FIELD_NUMBER: _ClassVar[int]
    TEST_ID_FIELD_NUMBER: _ClassVar[int]
    VARIANT_FIELD_NUMBER: _ClassVar[int]
    VARIANT_HASH_FIELD_NUMBER: _ClassVar[int]
    nominal_start_position: int
    previous_segment_nominal_end_position: int
    project: str
    ref: _sources_pb2.SourceRef
    ref_hash: str
    start_hour: _timestamp_pb2.Timestamp
    start_position_lower_bound_99th: int
    start_position_upper_bound_99th: int
    test_id: str
    variant: _common_pb2.Variant
    variant_hash: str
    def __init__(self, project: _Optional[str] = ..., test_id: _Optional[str] = ..., variant_hash: _Optional[str] = ..., variant: _Optional[_Union[_common_pb2.Variant, _Mapping]] = ..., ref_hash: _Optional[str] = ..., ref: _Optional[_Union[_sources_pb2.SourceRef, _Mapping]] = ..., start_hour: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., start_position_lower_bound_99th: _Optional[int] = ..., start_position_upper_bound_99th: _Optional[int] = ..., nominal_start_position: _Optional[int] = ..., previous_segment_nominal_end_position: _Optional[int] = ...) -> None: ...

class ChangepointGroupStatistics(_message.Message):
    __slots__ = ["count", "unexpected_verdict_rate_after", "unexpected_verdict_rate_before", "unexpected_verdict_rate_change", "unexpected_verdict_rate_current"]
    class RateChangeBuckets(_message.Message):
        __slots__ = ["count_increased_0_to_20_percent", "count_increased_20_to_50_percent", "count_increased_50_to_100_percent"]
        COUNT_INCREASED_0_TO_20_PERCENT_FIELD_NUMBER: _ClassVar[int]
        COUNT_INCREASED_20_TO_50_PERCENT_FIELD_NUMBER: _ClassVar[int]
        COUNT_INCREASED_50_TO_100_PERCENT_FIELD_NUMBER: _ClassVar[int]
        count_increased_0_to_20_percent: int
        count_increased_20_to_50_percent: int
        count_increased_50_to_100_percent: int
        def __init__(self, count_increased_0_to_20_percent: _Optional[int] = ..., count_increased_20_to_50_percent: _Optional[int] = ..., count_increased_50_to_100_percent: _Optional[int] = ...) -> None: ...
    class RateDistribution(_message.Message):
        __slots__ = ["average", "buckets"]
        class RateBuckets(_message.Message):
            __slots__ = ["count_above_5_less_than_95_percent", "count_above_95_percent", "count_less_5_percent"]
            COUNT_ABOVE_5_LESS_THAN_95_PERCENT_FIELD_NUMBER: _ClassVar[int]
            COUNT_ABOVE_95_PERCENT_FIELD_NUMBER: _ClassVar[int]
            COUNT_LESS_5_PERCENT_FIELD_NUMBER: _ClassVar[int]
            count_above_5_less_than_95_percent: int
            count_above_95_percent: int
            count_less_5_percent: int
            def __init__(self, count_less_5_percent: _Optional[int] = ..., count_above_5_less_than_95_percent: _Optional[int] = ..., count_above_95_percent: _Optional[int] = ...) -> None: ...
        AVERAGE_FIELD_NUMBER: _ClassVar[int]
        BUCKETS_FIELD_NUMBER: _ClassVar[int]
        average: float
        buckets: ChangepointGroupStatistics.RateDistribution.RateBuckets
        def __init__(self, average: _Optional[float] = ..., buckets: _Optional[_Union[ChangepointGroupStatistics.RateDistribution.RateBuckets, _Mapping]] = ...) -> None: ...
    COUNT_FIELD_NUMBER: _ClassVar[int]
    UNEXPECTED_VERDICT_RATE_AFTER_FIELD_NUMBER: _ClassVar[int]
    UNEXPECTED_VERDICT_RATE_BEFORE_FIELD_NUMBER: _ClassVar[int]
    UNEXPECTED_VERDICT_RATE_CHANGE_FIELD_NUMBER: _ClassVar[int]
    UNEXPECTED_VERDICT_RATE_CURRENT_FIELD_NUMBER: _ClassVar[int]
    count: int
    unexpected_verdict_rate_after: ChangepointGroupStatistics.RateDistribution
    unexpected_verdict_rate_before: ChangepointGroupStatistics.RateDistribution
    unexpected_verdict_rate_change: ChangepointGroupStatistics.RateChangeBuckets
    unexpected_verdict_rate_current: ChangepointGroupStatistics.RateDistribution
    def __init__(self, count: _Optional[int] = ..., unexpected_verdict_rate_before: _Optional[_Union[ChangepointGroupStatistics.RateDistribution, _Mapping]] = ..., unexpected_verdict_rate_after: _Optional[_Union[ChangepointGroupStatistics.RateDistribution, _Mapping]] = ..., unexpected_verdict_rate_current: _Optional[_Union[ChangepointGroupStatistics.RateDistribution, _Mapping]] = ..., unexpected_verdict_rate_change: _Optional[_Union[ChangepointGroupStatistics.RateChangeBuckets, _Mapping]] = ...) -> None: ...

class ChangepointGroupSummary(_message.Message):
    __slots__ = ["canonical_changepoint", "statistics"]
    CANONICAL_CHANGEPOINT_FIELD_NUMBER: _ClassVar[int]
    STATISTICS_FIELD_NUMBER: _ClassVar[int]
    canonical_changepoint: Changepoint
    statistics: ChangepointGroupStatistics
    def __init__(self, canonical_changepoint: _Optional[_Union[Changepoint, _Mapping]] = ..., statistics: _Optional[_Union[ChangepointGroupStatistics, _Mapping]] = ...) -> None: ...

class ChangepointPredicate(_message.Message):
    __slots__ = ["test_id_prefix", "unexpected_verdict_rate_change_range"]
    TEST_ID_PREFIX_FIELD_NUMBER: _ClassVar[int]
    UNEXPECTED_VERDICT_RATE_CHANGE_RANGE_FIELD_NUMBER: _ClassVar[int]
    test_id_prefix: str
    unexpected_verdict_rate_change_range: _common_pb2.NumericRange
    def __init__(self, test_id_prefix: _Optional[str] = ..., unexpected_verdict_rate_change_range: _Optional[_Union[_common_pb2.NumericRange, _Mapping]] = ...) -> None: ...

class QueryChangepointGroupSummariesRequest(_message.Message):
    __slots__ = ["predicate", "project"]
    PREDICATE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    predicate: ChangepointPredicate
    project: str
    def __init__(self, project: _Optional[str] = ..., predicate: _Optional[_Union[ChangepointPredicate, _Mapping]] = ...) -> None: ...

class QueryChangepointGroupSummariesResponse(_message.Message):
    __slots__ = ["group_summaries"]
    GROUP_SUMMARIES_FIELD_NUMBER: _ClassVar[int]
    group_summaries: _containers.RepeatedCompositeFieldContainer[ChangepointGroupSummary]
    def __init__(self, group_summaries: _Optional[_Iterable[_Union[ChangepointGroupSummary, _Mapping]]] = ...) -> None: ...

class QueryChangepointsInGroupRequest(_message.Message):
    __slots__ = ["group_key", "predicate", "project"]
    class ChangepointIdentifier(_message.Message):
        __slots__ = ["nominal_start_position", "ref_hash", "start_hour", "test_id", "variant_hash"]
        NOMINAL_START_POSITION_FIELD_NUMBER: _ClassVar[int]
        REF_HASH_FIELD_NUMBER: _ClassVar[int]
        START_HOUR_FIELD_NUMBER: _ClassVar[int]
        TEST_ID_FIELD_NUMBER: _ClassVar[int]
        VARIANT_HASH_FIELD_NUMBER: _ClassVar[int]
        nominal_start_position: int
        ref_hash: str
        start_hour: _timestamp_pb2.Timestamp
        test_id: str
        variant_hash: str
        def __init__(self, test_id: _Optional[str] = ..., variant_hash: _Optional[str] = ..., ref_hash: _Optional[str] = ..., nominal_start_position: _Optional[int] = ..., start_hour: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...
    GROUP_KEY_FIELD_NUMBER: _ClassVar[int]
    PREDICATE_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    group_key: QueryChangepointsInGroupRequest.ChangepointIdentifier
    predicate: ChangepointPredicate
    project: str
    def __init__(self, project: _Optional[str] = ..., group_key: _Optional[_Union[QueryChangepointsInGroupRequest.ChangepointIdentifier, _Mapping]] = ..., predicate: _Optional[_Union[ChangepointPredicate, _Mapping]] = ...) -> None: ...

class QueryChangepointsInGroupResponse(_message.Message):
    __slots__ = ["changepoints"]
    CHANGEPOINTS_FIELD_NUMBER: _ClassVar[int]
    changepoints: _containers.RepeatedCompositeFieldContainer[Changepoint]
    def __init__(self, changepoints: _Optional[_Iterable[_Union[Changepoint, _Mapping]]] = ...) -> None: ...
