from PB.google.api import field_behavior as _field_behavior_pb2
from google.protobuf import any_pb2 as _any_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from PB.go.chromium.org.luci.common.proto.git import commit as _commit_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import common as _common_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import sources as _sources_pb2
from PB.go.chromium.org.luci.analysis.proto.v1 import test_verdict as _test_verdict_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class BatchGetTestVariantBranchRequest(_message.Message):
    __slots__ = ["names"]
    NAMES_FIELD_NUMBER: _ClassVar[int]
    names: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, names: _Optional[_Iterable[str]] = ...) -> None: ...

class BatchGetTestVariantBranchResponse(_message.Message):
    __slots__ = ["test_variant_branches"]
    TEST_VARIANT_BRANCHES_FIELD_NUMBER: _ClassVar[int]
    test_variant_branches: _containers.RepeatedCompositeFieldContainer[TestVariantBranch]
    def __init__(self, test_variant_branches: _Optional[_Iterable[_Union[TestVariantBranch, _Mapping]]] = ...) -> None: ...

class GetRawTestVariantBranchRequest(_message.Message):
    __slots__ = ["name"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    name: str
    def __init__(self, name: _Optional[str] = ...) -> None: ...

class InputBuffer(_message.Message):
    __slots__ = ["length", "verdicts"]
    LENGTH_FIELD_NUMBER: _ClassVar[int]
    VERDICTS_FIELD_NUMBER: _ClassVar[int]
    length: int
    verdicts: _containers.RepeatedCompositeFieldContainer[PositionVerdict]
    def __init__(self, length: _Optional[int] = ..., verdicts: _Optional[_Iterable[_Union[PositionVerdict, _Mapping]]] = ...) -> None: ...

class PositionVerdict(_message.Message):
    __slots__ = ["commitPosition", "hour", "is_exonerated", "runs"]
    class Run(_message.Message):
        __slots__ = ["expected_abort_count", "expected_crash_count", "expected_fail_count", "expected_pass_count", "is_duplicate", "unexpected_abort_count", "unexpected_crash_count", "unexpected_fail_count", "unexpected_pass_count"]
        EXPECTED_ABORT_COUNT_FIELD_NUMBER: _ClassVar[int]
        EXPECTED_CRASH_COUNT_FIELD_NUMBER: _ClassVar[int]
        EXPECTED_FAIL_COUNT_FIELD_NUMBER: _ClassVar[int]
        EXPECTED_PASS_COUNT_FIELD_NUMBER: _ClassVar[int]
        IS_DUPLICATE_FIELD_NUMBER: _ClassVar[int]
        UNEXPECTED_ABORT_COUNT_FIELD_NUMBER: _ClassVar[int]
        UNEXPECTED_CRASH_COUNT_FIELD_NUMBER: _ClassVar[int]
        UNEXPECTED_FAIL_COUNT_FIELD_NUMBER: _ClassVar[int]
        UNEXPECTED_PASS_COUNT_FIELD_NUMBER: _ClassVar[int]
        expected_abort_count: int
        expected_crash_count: int
        expected_fail_count: int
        expected_pass_count: int
        is_duplicate: bool
        unexpected_abort_count: int
        unexpected_crash_count: int
        unexpected_fail_count: int
        unexpected_pass_count: int
        def __init__(self, expected_pass_count: _Optional[int] = ..., expected_fail_count: _Optional[int] = ..., expected_crash_count: _Optional[int] = ..., expected_abort_count: _Optional[int] = ..., unexpected_pass_count: _Optional[int] = ..., unexpected_fail_count: _Optional[int] = ..., unexpected_crash_count: _Optional[int] = ..., unexpected_abort_count: _Optional[int] = ..., is_duplicate: bool = ...) -> None: ...
    COMMITPOSITION_FIELD_NUMBER: _ClassVar[int]
    HOUR_FIELD_NUMBER: _ClassVar[int]
    IS_EXONERATED_FIELD_NUMBER: _ClassVar[int]
    RUNS_FIELD_NUMBER: _ClassVar[int]
    commitPosition: int
    hour: _timestamp_pb2.Timestamp
    is_exonerated: bool
    runs: _containers.RepeatedCompositeFieldContainer[PositionVerdict.Run]
    def __init__(self, commitPosition: _Optional[int] = ..., hour: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., is_exonerated: bool = ..., runs: _Optional[_Iterable[_Union[PositionVerdict.Run, _Mapping]]] = ...) -> None: ...

class QuerySourcePositionsRequest(_message.Message):
    __slots__ = ["page_size", "page_token", "project", "ref_hash", "start_source_position", "test_id", "variant_hash"]
    PAGE_SIZE_FIELD_NUMBER: _ClassVar[int]
    PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REF_HASH_FIELD_NUMBER: _ClassVar[int]
    START_SOURCE_POSITION_FIELD_NUMBER: _ClassVar[int]
    TEST_ID_FIELD_NUMBER: _ClassVar[int]
    VARIANT_HASH_FIELD_NUMBER: _ClassVar[int]
    page_size: int
    page_token: str
    project: str
    ref_hash: str
    start_source_position: int
    test_id: str
    variant_hash: str
    def __init__(self, project: _Optional[str] = ..., test_id: _Optional[str] = ..., variant_hash: _Optional[str] = ..., ref_hash: _Optional[str] = ..., start_source_position: _Optional[int] = ..., page_size: _Optional[int] = ..., page_token: _Optional[str] = ...) -> None: ...

class QuerySourcePositionsResponse(_message.Message):
    __slots__ = ["next_page_token", "source_positions"]
    NEXT_PAGE_TOKEN_FIELD_NUMBER: _ClassVar[int]
    SOURCE_POSITIONS_FIELD_NUMBER: _ClassVar[int]
    next_page_token: str
    source_positions: _containers.RepeatedCompositeFieldContainer[SourcePosition]
    def __init__(self, source_positions: _Optional[_Iterable[_Union[SourcePosition, _Mapping]]] = ..., next_page_token: _Optional[str] = ...) -> None: ...

class Segment(_message.Message):
    __slots__ = ["counts", "end_hour", "end_position", "has_start_changepoint", "start_hour", "start_position", "start_position_lower_bound_99th", "start_position_upper_bound_99th"]
    class Counts(_message.Message):
        __slots__ = ["flaky_verdicts", "total_verdicts", "unexpected_verdicts"]
        FLAKY_VERDICTS_FIELD_NUMBER: _ClassVar[int]
        TOTAL_VERDICTS_FIELD_NUMBER: _ClassVar[int]
        UNEXPECTED_VERDICTS_FIELD_NUMBER: _ClassVar[int]
        flaky_verdicts: int
        total_verdicts: int
        unexpected_verdicts: int
        def __init__(self, unexpected_verdicts: _Optional[int] = ..., flaky_verdicts: _Optional[int] = ..., total_verdicts: _Optional[int] = ...) -> None: ...
    COUNTS_FIELD_NUMBER: _ClassVar[int]
    END_HOUR_FIELD_NUMBER: _ClassVar[int]
    END_POSITION_FIELD_NUMBER: _ClassVar[int]
    HAS_START_CHANGEPOINT_FIELD_NUMBER: _ClassVar[int]
    START_HOUR_FIELD_NUMBER: _ClassVar[int]
    START_POSITION_FIELD_NUMBER: _ClassVar[int]
    START_POSITION_LOWER_BOUND_99TH_FIELD_NUMBER: _ClassVar[int]
    START_POSITION_UPPER_BOUND_99TH_FIELD_NUMBER: _ClassVar[int]
    counts: Segment.Counts
    end_hour: _timestamp_pb2.Timestamp
    end_position: int
    has_start_changepoint: bool
    start_hour: _timestamp_pb2.Timestamp
    start_position: int
    start_position_lower_bound_99th: int
    start_position_upper_bound_99th: int
    def __init__(self, has_start_changepoint: bool = ..., start_position: _Optional[int] = ..., start_position_lower_bound_99th: _Optional[int] = ..., start_position_upper_bound_99th: _Optional[int] = ..., start_hour: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., end_position: _Optional[int] = ..., end_hour: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., counts: _Optional[_Union[Segment.Counts, _Mapping]] = ...) -> None: ...

class SourcePosition(_message.Message):
    __slots__ = ["commit", "position", "verdicts"]
    COMMIT_FIELD_NUMBER: _ClassVar[int]
    POSITION_FIELD_NUMBER: _ClassVar[int]
    VERDICTS_FIELD_NUMBER: _ClassVar[int]
    commit: _commit_pb2.Commit
    position: int
    verdicts: _containers.RepeatedCompositeFieldContainer[_test_verdict_pb2.TestVerdict]
    def __init__(self, position: _Optional[int] = ..., commit: _Optional[_Union[_commit_pb2.Commit, _Mapping]] = ..., verdicts: _Optional[_Iterable[_Union[_test_verdict_pb2.TestVerdict, _Mapping]]] = ...) -> None: ...

class TestVariantBranch(_message.Message):
    __slots__ = ["name", "project", "ref", "ref_hash", "segments", "test_id", "variant", "variant_hash"]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REF_FIELD_NUMBER: _ClassVar[int]
    REF_HASH_FIELD_NUMBER: _ClassVar[int]
    SEGMENTS_FIELD_NUMBER: _ClassVar[int]
    TEST_ID_FIELD_NUMBER: _ClassVar[int]
    VARIANT_FIELD_NUMBER: _ClassVar[int]
    VARIANT_HASH_FIELD_NUMBER: _ClassVar[int]
    name: str
    project: str
    ref: _sources_pb2.SourceRef
    ref_hash: str
    segments: _containers.RepeatedCompositeFieldContainer[Segment]
    test_id: str
    variant: _common_pb2.Variant
    variant_hash: str
    def __init__(self, name: _Optional[str] = ..., project: _Optional[str] = ..., test_id: _Optional[str] = ..., variant_hash: _Optional[str] = ..., ref_hash: _Optional[str] = ..., variant: _Optional[_Union[_common_pb2.Variant, _Mapping]] = ..., ref: _Optional[_Union[_sources_pb2.SourceRef, _Mapping]] = ..., segments: _Optional[_Iterable[_Union[Segment, _Mapping]]] = ...) -> None: ...

class TestVariantBranchRaw(_message.Message):
    __slots__ = ["cold_buffer", "finalized_segments", "finalizing_segment", "hot_buffer", "name", "project", "ref", "ref_hash", "statistics", "test_id", "variant", "variant_hash"]
    COLD_BUFFER_FIELD_NUMBER: _ClassVar[int]
    FINALIZED_SEGMENTS_FIELD_NUMBER: _ClassVar[int]
    FINALIZING_SEGMENT_FIELD_NUMBER: _ClassVar[int]
    HOT_BUFFER_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    REF_FIELD_NUMBER: _ClassVar[int]
    REF_HASH_FIELD_NUMBER: _ClassVar[int]
    STATISTICS_FIELD_NUMBER: _ClassVar[int]
    TEST_ID_FIELD_NUMBER: _ClassVar[int]
    VARIANT_FIELD_NUMBER: _ClassVar[int]
    VARIANT_HASH_FIELD_NUMBER: _ClassVar[int]
    cold_buffer: InputBuffer
    finalized_segments: _any_pb2.Any
    finalizing_segment: _any_pb2.Any
    hot_buffer: InputBuffer
    name: str
    project: str
    ref: _sources_pb2.SourceRef
    ref_hash: str
    statistics: _any_pb2.Any
    test_id: str
    variant: _common_pb2.Variant
    variant_hash: str
    def __init__(self, name: _Optional[str] = ..., project: _Optional[str] = ..., test_id: _Optional[str] = ..., variant_hash: _Optional[str] = ..., ref_hash: _Optional[str] = ..., variant: _Optional[_Union[_common_pb2.Variant, _Mapping]] = ..., ref: _Optional[_Union[_sources_pb2.SourceRef, _Mapping]] = ..., finalized_segments: _Optional[_Union[_any_pb2.Any, _Mapping]] = ..., finalizing_segment: _Optional[_Union[_any_pb2.Any, _Mapping]] = ..., statistics: _Optional[_Union[_any_pb2.Any, _Mapping]] = ..., hot_buffer: _Optional[_Union[InputBuffer, _Mapping]] = ..., cold_buffer: _Optional[_Union[InputBuffer, _Mapping]] = ...) -> None: ...
